#include "stdafx.h"

const int N = 100;

typedef long Data;
typedef Data* PData;

void PrintArrayPart(PData, int, int);

void QuickSort(PData a, int Left, int Right)
{
#ifdef _DEBUG
	static int k = 0;
#endif

	int L = Left, R = Right;
	int C = a[(L + R) / 2];

	while (L <= R)
	{
		while (a[L] < C) L++;
		while (a[R] > C) R--;

		if (L <= R) { Data z = a[L]; a[L] = a[R]; a[R] = z;
					  L++; R--;
					}
	}

#ifdef _DEBUG
	printf("%3d#", ++k); PrintArrayPart(a, Left, Right);
#endif

	if (Left < R)  QuickSort(a, Left, R);
	if (L < Right) QuickSort(a, L, Right);
}

void FillArray(PData a, int n)
{
	for (int i = 0; i < n; i++) a[i] = rand()%1000;
}

#ifdef _DEBUG
void PrintArrayPart(PData a, int L, int R)
{
	printf("%3d:%3d|", L, R);
	for (int i = L; i <= R; i++) printf("%4d", a[i]);
	printf("\n");
}
#endif

void PrintArray(PData a, int n)
{
	for (int i = 0; i < n; i++) printf("%4d", a[i]);
	printf("\n");
}



int _tmain(int argc, _TCHAR* argv[])
{
	Data a[N];
	
	FillArray(a, N);			PrintArray(a, N);

	QuickSort(a, 0, N - 1);  	PrintArray(a, N);

	return 0;
}

